﻿Imports ThinkGeo.MapSuite.Core
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Globalization
Imports System.IO

Module Module1

    Sub Main()
        Console.WriteLine("Hello world")
        Dim fileName As String = "C:\Users\janagn.ANATEC\Desktop\AIS Data\points10daysGulf.shp"

        Dim shortPath As New StringBuilder(255)
        GetShortPathName(fileName, shortPath, shortPath.Capacity)
        Dim file = shortPath.ToString.Substring(shortPath.ToString.LastIndexOf("\") + 1)
        Dim atable As DataTable = ExcuteSqlUsingOledb("select obj_id, count(msg_id) from [" & file & "] group by obj_id", shortPath.ToString) ' where obj_id = 9960 order by msg_date
        Dim acollColelction = atable.Columns

        For Each aRow As DataRow In atable.Rows
            Console.WriteLine("ObjectID: " & aRow.Item(0) & " messages: " & aRow.Item(1))
            Dim objID As String = aRow.Item(0)
            ShapeFileFeatureSource.BuildIndexFile(fileName, "C:\Users\janagn.ANATEC\Desktop\AIS Data\points10daysGulfObject" & objID & ".idx", "obj_id", objID, BuildIndexMode.Rebuild)
            Dim aTrackLayer As ShapeFileFeatureLayer = New ShapeFileFeatureLayer(fileName, "C:\Users\janagn.ANATEC\Desktop\AIS Data\points10daysGulfObject" & objID & ".idx", ShapeFileReadWriteMode.ReadOnly)
            aTrackLayer.MaxRecordsToDraw = 9000
            aTrackLayer.Open()
            Dim allFeatures = aTrackLayer.QueryTools.GetFeaturesByColumnValue("obj_id", objID, ReturningColumnsType.AllColumns)
            aTrackLayer.Close()
        Next
        Console.WriteLine("End")

    End Sub

    <DllImport("kernel32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
    Public Function GetShortPathName(ByVal longPath As String, _
          <MarshalAs(UnmanagedType.LPTStr)> ByVal ShortPath As System.Text.StringBuilder, _
          <MarshalAs(Runtime.InteropServices.UnmanagedType.U4)> ByVal bufferSize As Integer) As Integer
    End Function
    Declare Unicode Function GetShortPathName2 Lib "kernel32.dll" Alias "GetShortPathNameW" (ByVal longPath As String, <MarshalAs(UnmanagedType.LPTStr)> ByVal ShortPath As System.Text.StringBuilder, <MarshalAs(UnmanagedType.U4)> ByVal bufferSize As Integer) As Integer
    Public Function ExcuteSqlUsingOledb(ByVal sqlStatement As String, ByVal shapeFileName As String) As DataTable
        Dim dataTable As New DataTable()
        dataTable.Locale = CultureInfo.InvariantCulture
        Dim oleDbCommand As OleDb.OleDbCommand = Nothing
        Dim adapter As OleDb.OleDbDataAdapter = Nothing
        Try
            oleDbCommand = GetOleDbCommand(sqlStatement, shapeFileName)
            adapter = New OleDb.OleDbDataAdapter(oleDbCommand)
            adapter.Fill(dataTable)
        Catch ex As Exception
            Console.Out.WriteLine(ex.Message)
        Finally
            If Not oleDbCommand Is Nothing Then
                oleDbCommand.Dispose()
            End If
            If Not adapter Is Nothing Then
                adapter.Dispose()
            End If
        End Try
        Return dataTable
    End Function
    Private Function GetOleDbCommand(ByRef sqlStatement As String, ByRef shapeFileName As String) As OleDb.OleDbCommand
        Dim connection As New OleDb.OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Path.GetDirectoryName(shapeFileName) & "\;Extended Properties=dBASE IV;User ID=Admin;Password=")
        If connection.State <> ConnectionState.Open Then
            connection.Open()
        End If
        Return New OleDb.OleDbCommand(sqlStatement, connection)
    End Function

End Module
